--[[
Extension for the 'FlieglMain' Specialization for the DPW 180.

Author: Ifko[nator]
Date: 21.12.2015
Version: 1.8

History: v 1.0 @ 16.09.2015 - intial release
		 v 1.5 @ 05.11.2015 - added support for the grass squarebales of my addBaleTypes Mod
		 v 1.8 @ 21.12.2015 - script optimizing

Website: http://www.modding-welt.com/index.php/BoardList
]]

FlieglMain_Extension_DPW180 = {};

local currentModName = g_currentModName;

function FlieglMain_Extension_DPW180.prerequisitesPresent(specializations)
    if SpecializationUtil.hasSpecialization(FlieglMain, specializations) then
		return true;
	else
		print("[ERROR from the FlieglMain_Extension_DPW180.lua]: Missing the specialization 'FlieglMain' in '" .. currentModName .. "'. Script is stopped now!");
		return false;
	end;
end;

function FlieglMain_Extension_DPW180:load(xmlFile)
	self.variableBodyParts = {};
	
	self.variableBodyParts.variableBodyPart1 = {};
	self.variableBodyParts.variableBodyPart1.visibleIndex1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.variableBodyParts.variableBodyPart1#visibleIndex1"));
	self.variableBodyParts.variableBodyPart1.visibleIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.variableBodyParts.variableBodyPart1#visibleIndex2"));
	
	self.variableBodyParts.variableBodyPart2 = {};
	self.variableBodyParts.variableBodyPart2.visibleIndex1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.variableBodyParts.variableBodyPart2#visibleIndex1"));
	self.variableBodyParts.variableBodyPart2.visibleIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.variableBodyParts.variableBodyPart2#visibleIndex2"));
	
	self.spanngurt = {};
	
	self.spanngurt.quaderballen = {};
	self.spanngurt.quaderballen.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen1#index"));
	self.spanngurt.quaderballen.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen2#index"));
	self.spanngurt.quaderballen.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen3#index"));
	self.spanngurt.quaderballen.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen4#index"));
	self.spanngurt.quaderballen.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen5#index"));
	self.spanngurt.quaderballen.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen6#index"));
	self.spanngurt.quaderballen.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen7#index"));
	self.spanngurt.quaderballen.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen8#index"));
	self.spanngurt.quaderballen.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen9#index"));
	self.spanngurt.quaderballen.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen10#index"));
	self.spanngurt.quaderballen.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen11#index"));
	self.spanngurt.quaderballen.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen12#index"));
	self.spanngurt.quaderballen.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen13#index"));
	self.spanngurt.quaderballen.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen14#index"));
	self.spanngurt.quaderballen.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen15#index"));
	self.spanngurt.quaderballen.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen16#index"));
	self.spanngurt.quaderballen.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen17#index"));
	self.spanngurt.quaderballen.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen18#index"));
	self.spanngurt.quaderballen.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen19#index"));
	self.spanngurt.quaderballen.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen20#index"));
	self.spanngurt.quaderballen.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen21#index"));
	self.spanngurt.quaderballen.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen22#index"));
	self.spanngurt.quaderballen.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen23#index"));
	self.spanngurt.quaderballen.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteQuaderballen.ballen24#index"));
	
	self.spanngurt.standardRundballen = {};
	self.spanngurt.standardRundballen.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen1#index"));
	self.spanngurt.standardRundballen.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen2#index"));
	self.spanngurt.standardRundballen.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen3#index"));
	self.spanngurt.standardRundballen.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen4#index"));
	self.spanngurt.standardRundballen.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen5#index"));
	self.spanngurt.standardRundballen.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen6#index"));
	self.spanngurt.standardRundballen.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen7#index"));
	self.spanngurt.standardRundballen.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen8#index"));
	self.spanngurt.standardRundballen.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen9#index"));
	self.spanngurt.standardRundballen.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen10#index"));
	self.spanngurt.standardRundballen.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen11#index"));
	self.spanngurt.standardRundballen.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen12#index"));
	self.spanngurt.standardRundballen.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen13#index"));
	self.spanngurt.standardRundballen.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen14#index"));
	self.spanngurt.standardRundballen.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen15#index"));
	self.spanngurt.standardRundballen.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen16#index"));
	self.spanngurt.standardRundballen.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen17#index"));
	self.spanngurt.standardRundballen.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen18#index"));
	self.spanngurt.standardRundballen.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen19#index"));
	self.spanngurt.standardRundballen.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen20#index"));
	self.spanngurt.standardRundballen.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen21#index"));
	self.spanngurt.standardRundballen.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen22#index"));
	self.spanngurt.standardRundballen.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen23#index"));
	self.spanngurt.standardRundballen.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen24#index"));
	self.spanngurt.standardRundballen.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen25#index"));
	self.spanngurt.standardRundballen.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen26#index"));
	self.spanngurt.standardRundballen.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen27#index"));
	self.spanngurt.standardRundballen.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen28#index"));
	self.spanngurt.standardRundballen.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen29#index"));
	self.spanngurt.standardRundballen.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteStandardRundballen.ballen30#index"));
	
	self.spanngurt.H_MilchKannen = {};
	self.spanngurt.H_MilchKannen.kanne1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne1#index"));
	self.spanngurt.H_MilchKannen.kanne2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne2#index"));
	self.spanngurt.H_MilchKannen.kanne3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne3#index"));
	self.spanngurt.H_MilchKannen.kanne4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne4#index"));
	self.spanngurt.H_MilchKannen.kanne5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne5#index"));
	self.spanngurt.H_MilchKannen.kanne6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne6#index"));
	self.spanngurt.H_MilchKannen.kanne7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne7#index"));
	self.spanngurt.H_MilchKannen.kanne8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne8#index"));
	self.spanngurt.H_MilchKannen.kanne9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne9#index"));
	self.spanngurt.H_MilchKannen.kanne10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne10#index"));
	self.spanngurt.H_MilchKannen.kanne11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne11#index"));
	self.spanngurt.H_MilchKannen.kanne12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne12#index"));
	self.spanngurt.H_MilchKannen.kanne13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne13#index"));
	self.spanngurt.H_MilchKannen.kanne14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne14#index"));
	self.spanngurt.H_MilchKannen.kanne15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne15#index"));
	self.spanngurt.H_MilchKannen.kanne16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne16#index"));
	self.spanngurt.H_MilchKannen.kanne17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne17#index"));
	self.spanngurt.H_MilchKannen.kanne18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne18#index"));
	self.spanngurt.H_MilchKannen.kanne19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne19#index"));
	self.spanngurt.H_MilchKannen.kanne20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne20#index"));
	self.spanngurt.H_MilchKannen.kanne21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne21#index"));
	self.spanngurt.H_MilchKannen.kanne22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne22#index"));
	self.spanngurt.H_MilchKannen.kanne23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne23#index"));
	self.spanngurt.H_MilchKannen.kanne24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne24#index"));
	self.spanngurt.H_MilchKannen.kanne25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne25#index"));
	self.spanngurt.H_MilchKannen.kanne26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne26#index"));
	self.spanngurt.H_MilchKannen.kanne27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne27#index"));
	self.spanngurt.H_MilchKannen.kanne28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne28#index"));
	self.spanngurt.H_MilchKannen.kanne29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne29#index"));
	self.spanngurt.H_MilchKannen.kanne30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteH_MilchKannen.kanne30#index"));
	
	self.spanngurt.baumsetzlingpaletten = {};
	self.spanngurt.baumsetzlingpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette1#index"));
	self.spanngurt.baumsetzlingpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette2#index"));
	self.spanngurt.baumsetzlingpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette3#index"));
	self.spanngurt.baumsetzlingpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette4#index"));
	self.spanngurt.baumsetzlingpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette5#index"));
	self.spanngurt.baumsetzlingpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette6#index"));
	self.spanngurt.baumsetzlingpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette7#index"));
	self.spanngurt.baumsetzlingpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette8#index"));
	self.spanngurt.baumsetzlingpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette9#index"));
	self.spanngurt.baumsetzlingpaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette10#index"));
	self.spanngurt.baumsetzlingpaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette11#index"));
	self.spanngurt.baumsetzlingpaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBaumsetzlingpaletten.palette12#index"));
	
	self.spanngurt.grosseBaumsetzlingpaletten = {};
	self.spanngurt.grosseBaumsetzlingpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette1#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette2#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette3#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette4#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette5#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette6#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette7#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette8#index"));
	self.spanngurt.grosseBaumsetzlingpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteGrosseBaumsetzlingpaletten.palette9#index"));
	
	self.spanngurt.holzpaletten = {};
	self.spanngurt.holzpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette1#index"));
	self.spanngurt.holzpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette2#index"));
	self.spanngurt.holzpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette3#index"));
	self.spanngurt.holzpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette4#index"));
	self.spanngurt.holzpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette5#index"));
	self.spanngurt.holzpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette6#index"));
	self.spanngurt.holzpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette7#index"));
	self.spanngurt.holzpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteHolzpaletten.palette8#index"));
	
	self.spanngurt.kartoffelpaletten = {};
	self.spanngurt.kartoffelpaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette1#index"));
	self.spanngurt.kartoffelpaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette2#index"));
	self.spanngurt.kartoffelpaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette3#index"));
	self.spanngurt.kartoffelpaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette4#index"));
	self.spanngurt.kartoffelpaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette5#index"));
	self.spanngurt.kartoffelpaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette6#index"));
	self.spanngurt.kartoffelpaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette7#index"));
	self.spanngurt.kartoffelpaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette8#index"));
	self.spanngurt.kartoffelpaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette9#index"));
	self.spanngurt.kartoffelpaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette10#index"));
	self.spanngurt.kartoffelpaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette11#index"));
	self.spanngurt.kartoffelpaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteKartoffelpaletten.palette12#index"));
	
	self.spanngurt.transportboxen = {};
	self.spanngurt.transportboxen.box1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box1#index"));
	self.spanngurt.transportboxen.box2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box2#index"));
	self.spanngurt.transportboxen.box3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box3#index"));
	self.spanngurt.transportboxen.box4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box4#index"));
	self.spanngurt.transportboxen.box5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box5#index"));
	self.spanngurt.transportboxen.box6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box6#index"));
	self.spanngurt.transportboxen.box7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box7#index"));
	self.spanngurt.transportboxen.box8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box8#index"));
	self.spanngurt.transportboxen.box9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box9#index"));
	self.spanngurt.transportboxen.box10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box10#index"));
	self.spanngurt.transportboxen.box11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box11#index"));
	self.spanngurt.transportboxen.box12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box12#index"));
	self.spanngurt.transportboxen.box13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box13#index"));
	self.spanngurt.transportboxen.box14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box14#index"));
	self.spanngurt.transportboxen.box15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box15#index"));
	self.spanngurt.transportboxen.box16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box16#index"));
	self.spanngurt.transportboxen.box17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box17#index"));
	self.spanngurt.transportboxen.box18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box18#index"));
	self.spanngurt.transportboxen.box19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box19#index"));
	self.spanngurt.transportboxen.box20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteTransportboxen.box20#index"));
	
	self.spanngurt.siliermittelTanks = {};
	self.spanngurt.siliermittelTanks.tank1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank1#index"));
	self.spanngurt.siliermittelTanks.tank2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank2#index"));
	self.spanngurt.siliermittelTanks.tank3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank3#index"));
	self.spanngurt.siliermittelTanks.tank4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank4#index"));
	self.spanngurt.siliermittelTanks.tank5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank5#index"));
	self.spanngurt.siliermittelTanks.tank6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank6#index"));
	self.spanngurt.siliermittelTanks.tank7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank7#index"));
	self.spanngurt.siliermittelTanks.tank8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank8#index"));
	self.spanngurt.siliermittelTanks.tank9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank9#index"));
	self.spanngurt.siliermittelTanks.tank10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank10#index"));
	self.spanngurt.siliermittelTanks.tank11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank11#index"));
	self.spanngurt.siliermittelTanks.tank12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteSiliermittelTanks.tank12#index"));
	
	--## BM Modding Bale support..
	self.spanngurt.BM_ModdingRundballen130Gewickelt = {};
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen26#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen27#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen28#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen29#index"));
	self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Gewickelt.ballen30#index"));
	
	self.spanngurt.BM_ModdingRundballen130Ungewickelt = {};
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen26#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen27#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen28#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen29#index"));
	self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen130Ungewickelt.ballen30#index"));
	
	self.spanngurt.BM_ModdingRundballen140Gewickelt = {};
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen26#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen27#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen28#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen29#index"));
	self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Gewickelt.ballen30#index"));
	
	self.spanngurt.BM_ModdingRundballen140Ungewickelt = {};
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen26#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen27 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen27#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen28 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen28#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen29 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen29#index"));
	self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen30 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen140Ungewickelt.ballen30#index"));
	
	self.spanngurt.BM_ModdingRundballen150Gewickelt = {};
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Gewickelt.ballen26#index"));
	
	self.spanngurt.BM_ModdingRundballen150Ungewickelt = {};
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen1#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen2#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen3#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen4#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen5#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen6#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen7#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen8#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen9#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen10#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen11#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen12#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen13 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen13#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen14 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen14#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen15 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen15#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen16 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen16#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen17 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen17#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen18 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen18#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen19 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen19#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen20 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen20#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen21 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen21#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen22 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen22#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen23 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen23#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen24 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen24#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen25 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen25#index"));
	self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen26 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.spanngurte.spanngurteBM_ModdingRundballen150Ungewickelt.ballen26#index"));
	
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	self.antirutschmatte = {};
	
	self.antirutschmatte.BM_ModdingPaletten = {};
	self.antirutschmatte.BM_ModdingPaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette1#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette2#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette3#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette4#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette5#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette6#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette7#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette8#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette9#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette10#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette11#index"));
	self.antirutschmatte.BM_ModdingPaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten.palette12#index"));
	
	self.gitterBM_ModdingPaletten = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenBM_ModdingPaletten#gitterIndex"));
	
	self.antirutschmatte.standardPaletten = {};
	self.antirutschmatte.standardPaletten.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette1#index"));
	self.antirutschmatte.standardPaletten.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette2#index"));
	self.antirutschmatte.standardPaletten.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette3#index"));
	self.antirutschmatte.standardPaletten.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette4#index"));
	self.antirutschmatte.standardPaletten.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette5#index"));
	self.antirutschmatte.standardPaletten.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette6#index"));
	self.antirutschmatte.standardPaletten.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette7#index"));
	self.antirutschmatte.standardPaletten.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette8#index"));
	self.antirutschmatte.standardPaletten.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette9#index"));
	self.antirutschmatte.standardPaletten.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette10#index"));
	self.antirutschmatte.standardPaletten.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette11#index"));
	self.antirutschmatte.standardPaletten.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten.palette12#index"));
	
	self.gitterStandardPaletten = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten#gitterIndex"));
	self.gitterWollPaletten = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenStandardPaletten#gitterWPIndex"));
	
	self.antirutschmatte.verbrauchsgueter = {};
	self.antirutschmatte.verbrauchsgueter.palette1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette1#index"));
	self.antirutschmatte.verbrauchsgueter.palette2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette2#index"));
	self.antirutschmatte.verbrauchsgueter.palette3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette3#index"));
	self.antirutschmatte.verbrauchsgueter.palette4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette4#index"));
	self.antirutschmatte.verbrauchsgueter.palette5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette5#index"));
	self.antirutschmatte.verbrauchsgueter.palette6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette6#index"));
	self.antirutschmatte.verbrauchsgueter.palette7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette7#index"));
	self.antirutschmatte.verbrauchsgueter.palette8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette8#index"));
	self.antirutschmatte.verbrauchsgueter.palette9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette9#index"));
	self.antirutschmatte.verbrauchsgueter.palette10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette10#index"));
	self.antirutschmatte.verbrauchsgueter.palette11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette11#index"));
	self.antirutschmatte.verbrauchsgueter.palette12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fliegl.antirutschmatten.antirutschmattenVerbrauchsgueter.palette12#index"));
end;

function FlieglMain_Extension_DPW180:delete()
end;

function FlieglMain_Extension_DPW180:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FlieglMain_Extension_DPW180:keyEvent(unicode, sym, modifier, isDown)
end;

function FlieglMain_Extension_DPW180:update(dt)
end;

function FlieglMain_Extension_DPW180:updateTick(dt)
	--## set help line's for the different product's 
	if self.choosenProductType[self.productType][1] == g_i18n:getText("WOOLPALLET") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BUYABLE_BLADES")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("CONSUMPTION_GOODS")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("PALLET")
	then
	
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.519, 0, 2.826);
			setTranslation(self.helpLineLeftStart2, 4.3, 0, 2.826);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.519, 0, 2.826); 
			setTranslation(self.helpLineRightStart2, -4.3, 0, 2.826);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -9.159);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -9.159);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.665, 0, 1.1);
			setTranslation(self.helpLineLeftStart2, 4.12, 0, 1.1);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.665, 0, 1.1);
			setTranslation(self.helpLineRightStart2, -4.12, 0, 1.1);	

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -10.903);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -10.903);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.519, 0, -0.634);
			setTranslation(self.helpLineLeftStart2, 4.3, 0, -0.634);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.519, 0, -0.634); 
			setTranslation(self.helpLineRightStart2, -4.3, 0, -0.634);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -12.65);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -12.65);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.519, 0, -2.388);
			setTranslation(self.helpLineLeftStart2, 4.3, 0, -2.388);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.519, 0, -2.388); 
			setTranslation(self.helpLineRightStart2, -4.3, 0, -2.388);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -14.379);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -14.379);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.519, 0, -4.119);
			setTranslation(self.helpLineLeftStart2, 4.3, 0, -4.119);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.519, 0, -4.119); 
			setTranslation(self.helpLineRightStart2, -4.3, 0, -4.119);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -16.14);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -16.14);
		elseif self.fillLevel >= 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.519, 0, -5.875);
			setTranslation(self.helpLineLeftStart2, 4.3, 0, -5.875);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.519, 0, -5.875); 
			setTranslation(self.helpLineRightStart2, -4.3, 0, -5.875);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.383, 0, -17.844);
			setTranslation(self.helpLineBackEnd2, -1.383, 0, -17.844);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.519, 0, 4.59);
		setTranslation(self.helpLineLeftEnd2, 4.3, 0, 4.59);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.519, 0, 4.59);
		setTranslation(self.helpLineRightEnd2, -4.3, 0, 4.59);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.383, 0, -7.453);
		setTranslation(self.helpLineBackStart2, -1.383, 0, -7.453); 
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_PALLETS") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, 2.957);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, 2.957);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, 2.957); 
			setTranslation(self.helpLineRightStart2, -4.1, 0, 2.957);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -9.05);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -9.05);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, 1.2);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, 1.2);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, 1.2);
			setTranslation(self.helpLineRightStart2, -4.1, 0, 1.2);	

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -10.79);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -10.79);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, -0.54);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, -0.54);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, -0.54); 
			setTranslation(self.helpLineRightStart2, -4.1, 0, -0.54);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -12.54);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -12.54);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, -2.25);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, -2.25);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, -2.25); 
			setTranslation(self.helpLineRightStart2, -4.1, 0, -2.25);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -14.25);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -14.25);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, -4.03);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, -4.03);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, -4.03); 
			setTranslation(self.helpLineRightStart2, -4.1, 0, -4.03);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -16);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -16);
		elseif self.fillLevel >= 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.691, 0, -5.76);
			setTranslation(self.helpLineLeftStart2, 4.1, 0, -5.76);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.691, 0, -5.76); 
			setTranslation(self.helpLineRightStart2, -4.1, 0, -5.76);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.21, 0, -17.75);
			setTranslation(self.helpLineBackEnd2, -1.21, 0, -17.75);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.691, 0, 4.45);
		setTranslation(self.helpLineLeftEnd2, 4.1, 0, 4.45);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.691, 0, 4.45);
		setTranslation(self.helpLineRightEnd2, -4.1, 0, 4.45);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.21, 0, -7.54);
		setTranslation(self.helpLineBackStart2, -1.21, 0, -7.54);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BOARDPALLET") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.556, 0, -0.48);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -0.48);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.556, 0, -0.48); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -0.48);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.35, 0, -12.49);
			setTranslation(self.helpLineBackEnd2, -1.35, 0, -12.49);
		elseif self.fillLevel >= 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.556, 0, -5.209);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -5.209);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.556, 0, -5.209); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -5.209);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.35, 0, -17.219);
			setTranslation(self.helpLineBackEnd2, -1.35, 0, -17.219);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.556, 0, 3.98);
		setTranslation(self.helpLineLeftEnd2, 4.22, 0, 3.98);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.556, 0, 3.98);
		setTranslation(self.helpLineRightEnd2, -4.22, 0, 3.98);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.35, 0, -8.038);
		setTranslation(self.helpLineBackStart2, -1.35, 0, -8.038); 
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("WASHEDPOTATOPALLET") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.334, 0, 1.23);
			setTranslation(self.helpLineLeftStart2, 4.52, 0, 1.23);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.334, 0, 1.23); 
			setTranslation(self.helpLineRightStart2, -4.52, 0, 1.23);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.602, 0, -10.783);
			setTranslation(self.helpLineBackEnd2, -1.602, 0, -10.783);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.334, 0, -2.07);
			setTranslation(self.helpLineLeftStart2, 4.52, 0, -2.07);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.334, 0, -2.07); 
			setTranslation(self.helpLineRightStart2, -4.52, 0, -2.07);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.602, 0, -14.078);
			setTranslation(self.helpLineBackEnd2, -1.602, 0, -14.078);
		elseif self.fillLevel >= 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.334, 0, -5.363);
			setTranslation(self.helpLineLeftStart2, 4.52, 0, -5.363);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.334, 0, -5.363); 
			setTranslation(self.helpLineRightStart2, -4.52, 0, -5.363);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.602, 0, -17.349);
			setTranslation(self.helpLineBackEnd2, -1.602, 0, -17.349);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.334, 0, 4.343);
		setTranslation(self.helpLineLeftEnd2, 4.52, 0, 4.343);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.334, 0, 4.343);
		setTranslation(self.helpLineRightEnd2, -4.52, 0, 4.343);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.602, 0, -7.668);
		setTranslation(self.helpLineBackStart2, -1.602, 0, -7.668); 
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STRAW_SQUAREBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("HAY_SQUAREBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("GRASS_SQUAREBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("MIX_SQUAREBALE") 
	then
	
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.665, 0, 2.07);
			setTranslation(self.helpLineLeftStart2, 4.12, 0, 2.07);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.665, 0, 2.07); 
			setTranslation(self.helpLineRightStart2, -4.12, 0, 2.07);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.242, 0, -9.936);
			setTranslation(self.helpLineBackEnd2, -1.242, 0, -9.936);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.665, 0, -0.38);
			setTranslation(self.helpLineLeftStart2, 4.12, 0, -0.38);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.665, 0, -0.38); 
			setTranslation(self.helpLineRightStart2, -4.12, 0, -0.38);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.242, 0, -12.369);
			setTranslation(self.helpLineBackEnd2, -1.242, 0, -12.369);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.665, 0, -2.841);
			setTranslation(self.helpLineLeftStart2, 4.12, 0, -2.841);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.665, 0, -2.841); 
			setTranslation(self.helpLineRightStart2, -4.12, 0, -2.841);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.242, 0, -14.835);
			setTranslation(self.helpLineBackEnd2, -1.242, 0, -14.835);
		elseif self.fillLevel >= 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.665, 0, -5.3);
			setTranslation(self.helpLineLeftStart2, 4.12, 0, -5.3);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.665, 0, -5.3); 
			setTranslation(self.helpLineRightStart2, -4.12, 0, -5.3);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.242, 0, -17.307);
			setTranslation(self.helpLineBackEnd2, -1.242, 0, -17.307);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.665, 0, 4.5);
		setTranslation(self.helpLineLeftEnd2, 4.12, 0, 4.5);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.665, 0, 4.5);
		setTranslation(self.helpLineRightEnd2, -4.12, 0, 4.5);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.242, 0, -7.522);
		setTranslation(self.helpLineBackStart2, -1.242, 0, -7.522); 
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_STRAW_ROUNDBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_HAY_ROUNDBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_GRASS_ROUNDBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_SILAGE_ROUNDBALE") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_MIX_ROUNDBALE") 
		
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_130") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_130") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_130")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_130") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_130") 
	then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 3.74);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 3.74);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 3.74); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 3.74);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -8.258);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -8.258);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 2.448);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 2.448);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 2.448); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 2.448);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.546);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.546);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 1.144);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 1.144);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 1.144); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 1.144);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -10.837);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -10.837);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -0.161);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -0.161);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -0.161); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -0.161);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -12.149);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -12.149);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -1.539);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -1.539);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -1.539); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -1.539);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -13.453);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -13.453);
		elseif self.fillLevel < 13 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -2.757);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -2.757);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -2.757); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -2.757);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -14.76);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -14.76);
		elseif self.fillLevel < 15 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -4.054);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -4.054);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -4.054); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -4.054);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -16.047);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -16.047);
		elseif self.fillLevel >= 15 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -5.345);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -5.345);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -5.345); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -5.345);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -17.325);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -17.325);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.726, 0, 5.05);
		setTranslation(self.helpLineLeftEnd2, 4.08, 0, 5.05);
		
		--## right help line's 
		setTranslation(self.helpLineRightEnd, -1.726, 0, 5.05);
		setTranslation(self.helpLineRightEnd2, -4.08, 0, 5.05);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -6.952);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -6.952); 
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_140") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_140") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_140")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_140") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_140") 
	then
	
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 3.7);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 3.7);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 3.7); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 3.7);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -8.29);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -8.29);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 2.3);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 2.3);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 2.3); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 2.3);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.69);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.69);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 0.91);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 0.91);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 0.91); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 0.91);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -11.08);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -11.08);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -0.5);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -0.5);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -0.5); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -0.5);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -12.5);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -12.5);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -1.9);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -1.9);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -1.9); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -1.9);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -13.9);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -13.9);
		elseif self.fillLevel < 13 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -3.3);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -3.3);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -3.3); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -3.3);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -15.3);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -15.3);
		elseif self.fillLevel < 15 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -4.69);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -4.69);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -4.69); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -4.69);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -16.7);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -16.5);
		elseif self.fillLevel >= 15 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -6.1);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -6.1);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -6.1); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -6.1);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -18.1);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -18.1);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.726, 0, 5.1);
		setTranslation(self.helpLineLeftEnd2, 4.08, 0, 5.1);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.726, 0, 5.1);
		setTranslation(self.helpLineRightEnd2, -4.08, 0, 5.1);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -6.9);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -6.9);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_150") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_150") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_150")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_150") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_150") 
	then
	
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 3.62);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 3.62);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 3.62); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 3.62);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -8.395);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -8.395);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 2.11);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 2.11);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 2.11); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 2.11);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.9);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.9);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 0.606);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 0.606);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 0.606); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 0.606);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -11.4);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -11.4);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -0.89);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -0.89);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -0.89); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -0.89);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -12.9);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -12.9);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -2.386);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -2.386);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -2.386); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -2.386);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -14.11);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -14.11);
		elseif self.fillLevel < 13 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -3.9);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -3.9);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -3.9); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -3.9);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -15.9);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -15.9);
		elseif self.fillLevel >= 13 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -5.4);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -5.4);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -5.4); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -5.4);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -17.4);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -17.4);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.726, 0, 5.1);
		setTranslation(self.helpLineLeftEnd2, 4.08, 0, 5.1);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.726, 0, 5.1);
		setTranslation(self.helpLineRightEnd2, -4.08, 0, 5.1);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -6.91);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -6.91);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_TREESAPLINGPALLET") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, 2.967);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, 2.967);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, 2.967); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, 2.967);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.024);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.024);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, 1.247);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, 1.247);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, 1.247); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, 1.247);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -10.763);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -10.763);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -0.505);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -0.505);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -0.505); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -0.505);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -12.51);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -12.51);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -2.226);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -2.226);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -2.226); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -2.226);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -14.224);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -14.224);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -3.976);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -3.976);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -3.976); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -3.976);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -15.975);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -15.975);
		elseif self.fillLevel >= 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -5.722);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -5.722);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -5.722); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -5.722);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -17.729);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -17.729);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.693, 0, 5.05);
		setTranslation(self.helpLineLeftEnd2, 4.114, 0, 5.05);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.693, 0, 5.05);
		setTranslation(self.helpLineRightEnd2, -4.114, 0, 5.05);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -7.585);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -7.585);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BIG_TREESAPLINGPALLET") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, 2.48);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, 2.48);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, 2.48); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, 2.48);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.52);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.52);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, 0.22);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, 0.22);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, 0.22); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, 0.22);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -11.78);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -11.78);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -2);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -2);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -2); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -2);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -14.03);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -14.03);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -4.28);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -4.28);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -4.28); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -4.28);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -16.29);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -16.29);
		elseif self.fillLevel == 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.693, 0, -5.37);
			setTranslation(self.helpLineLeftStart2, 4.114, 0, -5.37);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.693, 0, -5.37); 
			setTranslation(self.helpLineRightStart2, -4.114, 0, -5.37);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -17.37);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -17.37);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.693, 0, 4.62);
		setTranslation(self.helpLineLeftEnd2, 4.114, 0, 4.62);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.693, 0, 4.62);
		setTranslation(self.helpLineRightEnd2, -4.114, 0, 4.62);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -3.89);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -3.89); 
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("TRANSPORTBOX") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.75, 0, 2.42);
			setTranslation(self.helpLineLeftStart2, 4.055, 0, 2.42);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.75, 0, 2.42); 
			setTranslation(self.helpLineRightStart2, -4.055, 0, 2.42);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.155, 0, -9.57);
			setTranslation(self.helpLineBackEnd2, -1.155, 0, -9.57);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.75, 0, 0.59);
			setTranslation(self.helpLineLeftStart2, 4.055, 0, 0.59);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.75, 0, 1.095); 
			setTranslation(self.helpLineRightStart2, -4.055, 0, 1.095);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.155, 0, -11.41);
			setTranslation(self.helpLineBackEnd2, -1.155, 0, -11.41);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.75, 0, -1.22);
			setTranslation(self.helpLineLeftStart2, 4.055, 0, -1.22);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.75, 0, -1.22); 
			setTranslation(self.helpLineRightStart2, -4.055, 0, -1.22);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.155, 0, -13.22);
			setTranslation(self.helpLineBackEnd2, -1.155, 0, -13.22);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.75, 0, -3.04);
			setTranslation(self.helpLineLeftStart2, 4.055, 0, -3.04);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.75, 0, -3.04); 
			setTranslation(self.helpLineRightStart2, -4.055, 0, -3.04);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.155, 0, -15.04);
			setTranslation(self.helpLineBackEnd2, -1.155, 0, -15.04);
		elseif self.fillLevel >= 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.75, 0, -4.885);
			setTranslation(self.helpLineLeftStart2, 4.055, 0, -4.885);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.75, 0, -4.885); 
			setTranslation(self.helpLineRightStart2, -4.055, 0, -4.885);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.155, 0, -16.9);
			setTranslation(self.helpLineBackEnd2, -1.155, 0, -16.9);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.75, 0, 4.17);
		setTranslation(self.helpLineLeftEnd2, 4.055, 0, 4.17);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.75, 0, 4.17);
		setTranslation(self.helpLineRightEnd2, -4.055, 0, 4.17);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.155, 0, -7.82);
		setTranslation(self.helpLineBackStart2, -1.155, 0, -7.82); 
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("SILAGE_ADDITIVES_TANK") then
		
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 3 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, 2.96);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, 2.96);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, 2.96); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, 2.96);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -9.03);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -9.03);
		elseif self.fillLevel < 5 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, 1.22);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, 1.22);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, 1.22); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, 1.22);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -10.78);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -10.78);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, -0.52);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -0.52);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, -0.52); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -0.52);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -12.62);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -12.62);
		elseif self.fillLevel < 9 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, -2.27);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -2.27);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, -2.27); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -2.27);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -14.27);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -14.27);
		elseif self.fillLevel < 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, -3.98);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -3.98);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, -3.98); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -3.98);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -15.98);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -15.98);
		elseif self.fillLevel >= 11 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.58, 0, -5.66);
			setTranslation(self.helpLineLeftStart2, 4.22, 0, -5.66);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.58, 0, -5.66); 
			setTranslation(self.helpLineRightStart2, -4.22, 0, -5.66);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.32, 0, -17.66);
			setTranslation(self.helpLineBackEnd2, -1.32, 0, -17.66);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.58, 0, 4.61);
		setTranslation(self.helpLineLeftEnd2, 4.22, 0, 4.61);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.58, 0, 4.61);
		setTranslation(self.helpLineRightEnd2, -4.22, 0, 4.61);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.32, 0, -7.4);
		setTranslation(self.helpLineBackStart2, -1.32, 0, -7.4);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("H_MILK") then
	
		--## set the length of the help line's to the current fill level
		if self.fillLevel < 4 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 3.74);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 3.74);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 3.74); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 3.74);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -8.27);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -8.27);
		elseif self.fillLevel < 7 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 2.66);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 2.66);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 2.66); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 2.66);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -9.33);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -9.33);
		elseif self.fillLevel < 10 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 1.606);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 1.606);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 1.606); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 1.606);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -10.39);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -10.39);
		elseif self.fillLevel < 13 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, 0.54);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, 0.54);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, 0.54); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, 0.54);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -11.46);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -11.46);
		elseif self.fillLevel < 16 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -0.53);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -0.53);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -0.53); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -0.53);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -12.52);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -12.52);
		elseif self.fillLevel < 19 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -1.59);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -1.59);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -1.59); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -1.59);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -13.59);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -13.59);
		elseif self.fillLevel < 22 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -2.67);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -2.67);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -2.67); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -2.67);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -14.67);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -14.67);
		elseif self.fillLevel < 25 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -3.73);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -3.73);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -3.73); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -3.73);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -15.73);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -15.73);
		elseif self.fillLevel < 28 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -4.78);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -4.78);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -4.78); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -4.78);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -16.78);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -16.78);
		elseif self.fillLevel >= 28 then
			--## left help line's
			setTranslation(self.helpLineLeftStart, 1.726, 0, -5.85);
			setTranslation(self.helpLineLeftStart2, 4.08, 0, -5.85);
			
			--## right help line's
			setTranslation(self.helpLineRightStart, -1.726, 0, -5.85); 
			setTranslation(self.helpLineRightStart2, -4.08, 0, -5.85);

			--## back help line's
			setTranslation(self.helpLineBackEnd, 1.182, 0, -17.85);
			setTranslation(self.helpLineBackEnd2, -1.182, 0, -17.85);
		end;
		
		--## left help line's
		setTranslation(self.helpLineLeftEnd, 1.726, 0, 4.78);
		setTranslation(self.helpLineLeftEnd2, 4.08, 0, 4.78);
		
		--## right help line's
		setTranslation(self.helpLineRightEnd, -1.726, 0, 4.78);
		setTranslation(self.helpLineRightEnd2, -4.08, 0, 4.78);
		
		--## back help line's
		setTranslation(self.helpLineBackStart, 1.182, 0, -7.22);
		setTranslation(self.helpLineBackStart2, -1.182, 0, -7.22);
	end;
		
	if self.choosenProductType[self.productType][1] == g_i18n:getText("STRAW_SQUAREBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("HAY_SQUAREBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("GRASS_SQUAREBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("MIX_SQUAREBALE") 
	then
		setVisibility(self.spanngurt.quaderballen.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.quaderballen.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.quaderballen.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.quaderballen.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.quaderballen.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.quaderballen.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.quaderballen.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.quaderballen.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.quaderballen.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.quaderballen.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.quaderballen.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.quaderballen.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.quaderballen.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.quaderballen.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.quaderballen.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.quaderballen.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.quaderballen.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.quaderballen.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.quaderballen.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.quaderballen.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.quaderballen.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.quaderballen.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.quaderballen.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.quaderballen.ballen24, self.fillLevel == 24);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_STRAW_ROUNDBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_HAY_ROUNDBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_GRASS_ROUNDBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_SILAGE_ROUNDBALE") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_MIX_ROUNDBALE") 
	then
		setVisibility(self.spanngurt.standardRundballen.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.standardRundballen.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.standardRundballen.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.standardRundballen.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.standardRundballen.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.standardRundballen.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.standardRundballen.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.standardRundballen.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.standardRundballen.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.standardRundballen.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.standardRundballen.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.standardRundballen.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.standardRundballen.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.standardRundballen.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.standardRundballen.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.standardRundballen.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.standardRundballen.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.standardRundballen.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.standardRundballen.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.standardRundballen.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.standardRundballen.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.standardRundballen.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.standardRundballen.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.standardRundballen.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.standardRundballen.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.standardRundballen.ballen26, self.fillLevel == 26);
		setVisibility(self.spanngurt.standardRundballen.ballen27, self.fillLevel == 27);
		setVisibility(self.spanngurt.standardRundballen.ballen28, self.fillLevel == 28);
		setVisibility(self.spanngurt.standardRundballen.ballen29, self.fillLevel == 29);
		setVisibility(self.spanngurt.standardRundballen.ballen30, self.fillLevel == 30);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_130") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_130") 
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen26, self.fillLevel == 26);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen27, self.fillLevel == 27);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen28, self.fillLevel == 28);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen29, self.fillLevel == 29);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Gewickelt.ballen30, self.fillLevel == 30);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_130") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_130") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_130")
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen26, self.fillLevel == 26);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen27, self.fillLevel == 27);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen28, self.fillLevel == 28);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen29, self.fillLevel == 29);
		setVisibility(self.spanngurt.BM_ModdingRundballen130Ungewickelt.ballen30, self.fillLevel == 30);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_140") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_140") 
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen26, self.fillLevel == 26);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen27, self.fillLevel == 27);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen28, self.fillLevel == 28);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen29, self.fillLevel == 29);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Gewickelt.ballen30, self.fillLevel == 30);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_140") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_140") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_140")
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen26, self.fillLevel == 26);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen27, self.fillLevel == 27);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen28, self.fillLevel == 28);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen29, self.fillLevel == 29);
		setVisibility(self.spanngurt.BM_ModdingRundballen140Ungewickelt.ballen30, self.fillLevel == 30);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_SILAGE_ROUNDBALE_150") 			
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_MIX_ROUNDBALE_150") 
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Gewickelt.ballen26, self.fillLevel == 26);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_STRAW_ROUNDBALE_150") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_HAY_ROUNDBALE_150") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_GRASS_ROUNDBALE_150")
	then
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen1, self.fillLevel == 1);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen2, self.fillLevel == 2);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen3, self.fillLevel == 3);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen4, self.fillLevel == 4);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen5, self.fillLevel == 5);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen6, self.fillLevel == 6);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen7, self.fillLevel == 7);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen8, self.fillLevel == 8);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen9, self.fillLevel == 9);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen10, self.fillLevel == 10);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen11, self.fillLevel == 11);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen12, self.fillLevel == 12);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen13, self.fillLevel == 13);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen14, self.fillLevel == 14);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen15, self.fillLevel == 15);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen16, self.fillLevel == 16);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen17, self.fillLevel == 17);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen18, self.fillLevel == 18);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen19, self.fillLevel == 19);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen20, self.fillLevel == 20);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen21, self.fillLevel == 21);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen22, self.fillLevel == 22);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen23, self.fillLevel == 23);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen24, self.fillLevel == 24);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen25, self.fillLevel == 25);
		setVisibility(self.spanngurt.BM_ModdingRundballen150Ungewickelt.ballen26, self.fillLevel == 26);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_TREESAPLINGPALLET") then
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette1, self.fillLevel == 1);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette2, self.fillLevel == 2);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette3, self.fillLevel == 3);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette4, self.fillLevel == 4);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette5, self.fillLevel == 5);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette6, self.fillLevel == 6);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette7, self.fillLevel == 7);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette8, self.fillLevel == 8);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette9, self.fillLevel == 9);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette10, self.fillLevel == 10);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette11, self.fillLevel == 11);
		setVisibility(self.spanngurt.baumsetzlingpaletten.palette12, self.fillLevel == 12);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BIG_TREESAPLINGPALLET") then
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette1, self.fillLevel == 1);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette2, self.fillLevel == 2);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette3, self.fillLevel == 3);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette4, self.fillLevel == 4);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette5, self.fillLevel == 5);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette6, self.fillLevel == 6);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette7, self.fillLevel == 7);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette8, self.fillLevel == 8);
		setVisibility(self.spanngurt.grosseBaumsetzlingpaletten.palette9, self.fillLevel == 9);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("BOARDPALLET") then
		setVisibility(self.spanngurt.holzpaletten.palette1, self.fillLevel == 1);
		setVisibility(self.spanngurt.holzpaletten.palette2, self.fillLevel == 2);
		setVisibility(self.spanngurt.holzpaletten.palette3, self.fillLevel == 3);
		setVisibility(self.spanngurt.holzpaletten.palette4, self.fillLevel == 4);
		setVisibility(self.spanngurt.holzpaletten.palette5, self.fillLevel == 5);
		setVisibility(self.spanngurt.holzpaletten.palette6, self.fillLevel == 6);
		setVisibility(self.spanngurt.holzpaletten.palette7, self.fillLevel == 7);
		setVisibility(self.spanngurt.holzpaletten.palette8, self.fillLevel == 8);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("WASHEDPOTATOPALLET") then
		setVisibility(self.spanngurt.kartoffelpaletten.palette1, self.fillLevel == 1);
		setVisibility(self.spanngurt.kartoffelpaletten.palette2, self.fillLevel == 2);
		setVisibility(self.spanngurt.kartoffelpaletten.palette3, self.fillLevel == 3);
		setVisibility(self.spanngurt.kartoffelpaletten.palette4, self.fillLevel == 4);
		setVisibility(self.spanngurt.kartoffelpaletten.palette5, self.fillLevel == 5);
		setVisibility(self.spanngurt.kartoffelpaletten.palette6, self.fillLevel == 6);
		setVisibility(self.spanngurt.kartoffelpaletten.palette7, self.fillLevel == 7);
		setVisibility(self.spanngurt.kartoffelpaletten.palette8, self.fillLevel == 8);
		setVisibility(self.spanngurt.kartoffelpaletten.palette9, self.fillLevel == 9);
		setVisibility(self.spanngurt.kartoffelpaletten.palette10, self.fillLevel == 10);
		setVisibility(self.spanngurt.kartoffelpaletten.palette11, self.fillLevel == 11);
		setVisibility(self.spanngurt.kartoffelpaletten.palette12, self.fillLevel == 12);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("TRANSPORTBOX") then
		setVisibility(self.spanngurt.transportboxen.box1, self.fillLevel == 1);
		setVisibility(self.spanngurt.transportboxen.box2, self.fillLevel == 2);
		setVisibility(self.spanngurt.transportboxen.box3, self.fillLevel == 3);
		setVisibility(self.spanngurt.transportboxen.box4, self.fillLevel == 4);
		setVisibility(self.spanngurt.transportboxen.box5, self.fillLevel == 5);
		setVisibility(self.spanngurt.transportboxen.box6, self.fillLevel == 6);
		setVisibility(self.spanngurt.transportboxen.box7, self.fillLevel == 7);
		setVisibility(self.spanngurt.transportboxen.box8, self.fillLevel == 8);
		setVisibility(self.spanngurt.transportboxen.box9, self.fillLevel == 9);
		setVisibility(self.spanngurt.transportboxen.box10, self.fillLevel == 10);
		setVisibility(self.spanngurt.transportboxen.box11, self.fillLevel == 11);
		setVisibility(self.spanngurt.transportboxen.box12, self.fillLevel == 12);
		setVisibility(self.spanngurt.transportboxen.box13, self.fillLevel == 13);
		setVisibility(self.spanngurt.transportboxen.box14, self.fillLevel == 14);
		setVisibility(self.spanngurt.transportboxen.box15, self.fillLevel == 15);
		setVisibility(self.spanngurt.transportboxen.box16, self.fillLevel == 16);
		setVisibility(self.spanngurt.transportboxen.box17, self.fillLevel == 17);
		setVisibility(self.spanngurt.transportboxen.box18, self.fillLevel == 18);
		setVisibility(self.spanngurt.transportboxen.box19, self.fillLevel == 19);
		setVisibility(self.spanngurt.transportboxen.box20, self.fillLevel == 20);
		
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("SILAGE_ADDITIVES_TANK") then
		setVisibility(self.spanngurt.siliermittelTanks.tank1, self.fillLevel == 1);
		setVisibility(self.spanngurt.siliermittelTanks.tank2, self.fillLevel == 2);
		setVisibility(self.spanngurt.siliermittelTanks.tank3, self.fillLevel == 3);
		setVisibility(self.spanngurt.siliermittelTanks.tank4, self.fillLevel == 4);
		setVisibility(self.spanngurt.siliermittelTanks.tank5, self.fillLevel == 5);
		setVisibility(self.spanngurt.siliermittelTanks.tank6, self.fillLevel == 6);
		setVisibility(self.spanngurt.siliermittelTanks.tank7, self.fillLevel == 7);
		setVisibility(self.spanngurt.siliermittelTanks.tank8, self.fillLevel == 8);
		setVisibility(self.spanngurt.siliermittelTanks.tank9, self.fillLevel == 9);
		setVisibility(self.spanngurt.siliermittelTanks.tank10, self.fillLevel == 10);
		setVisibility(self.spanngurt.siliermittelTanks.tank11, self.fillLevel == 11);
		setVisibility(self.spanngurt.siliermittelTanks.tank12, self.fillLevel == 12);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("H_MILK") then
		setVisibility(self.spanngurt.H_MilchKannen.kanne1, self.fillLevel == 1);
		setVisibility(self.spanngurt.H_MilchKannen.kanne2, self.fillLevel == 2);
		setVisibility(self.spanngurt.H_MilchKannen.kanne3, self.fillLevel == 3);
		setVisibility(self.spanngurt.H_MilchKannen.kanne4, self.fillLevel == 4);
		setVisibility(self.spanngurt.H_MilchKannen.kanne5, self.fillLevel == 5);
		setVisibility(self.spanngurt.H_MilchKannen.kanne6, self.fillLevel == 6);
		setVisibility(self.spanngurt.H_MilchKannen.kanne7, self.fillLevel == 7);
		setVisibility(self.spanngurt.H_MilchKannen.kanne8, self.fillLevel == 8);
		setVisibility(self.spanngurt.H_MilchKannen.kanne9, self.fillLevel == 9);
		setVisibility(self.spanngurt.H_MilchKannen.kanne10, self.fillLevel == 10);
		setVisibility(self.spanngurt.H_MilchKannen.kanne11, self.fillLevel == 11);
		setVisibility(self.spanngurt.H_MilchKannen.kanne12, self.fillLevel == 12);
		setVisibility(self.spanngurt.H_MilchKannen.kanne13, self.fillLevel == 13);
		setVisibility(self.spanngurt.H_MilchKannen.kanne14, self.fillLevel == 14);
		setVisibility(self.spanngurt.H_MilchKannen.kanne15, self.fillLevel == 15);
		setVisibility(self.spanngurt.H_MilchKannen.kanne16, self.fillLevel == 16);
		setVisibility(self.spanngurt.H_MilchKannen.kanne17, self.fillLevel == 17);
		setVisibility(self.spanngurt.H_MilchKannen.kanne18, self.fillLevel == 18);
		setVisibility(self.spanngurt.H_MilchKannen.kanne19, self.fillLevel == 19);
		setVisibility(self.spanngurt.H_MilchKannen.kanne20, self.fillLevel == 20);
		setVisibility(self.spanngurt.H_MilchKannen.kanne21, self.fillLevel == 21);
		setVisibility(self.spanngurt.H_MilchKannen.kanne22, self.fillLevel == 22);
		setVisibility(self.spanngurt.H_MilchKannen.kanne23, self.fillLevel == 23);
		setVisibility(self.spanngurt.H_MilchKannen.kanne24, self.fillLevel == 24);
		setVisibility(self.spanngurt.H_MilchKannen.kanne25, self.fillLevel == 25);
		setVisibility(self.spanngurt.H_MilchKannen.kanne26, self.fillLevel == 26);
		setVisibility(self.spanngurt.H_MilchKannen.kanne27, self.fillLevel == 27);
		setVisibility(self.spanngurt.H_MilchKannen.kanne28, self.fillLevel == 28);
		setVisibility(self.spanngurt.H_MilchKannen.kanne29, self.fillLevel == 29);
		setVisibility(self.spanngurt.H_MilchKannen.kanne30, self.fillLevel == 30);
	end;

	setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, true);
	setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, true);
	setVisibility(self.gitterWollPaletten, false);
	setVisibility(self.gitterStandardPaletten, false);
	setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex1, false);
	setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex2, false);
	
	if self.choosenProductType[self.productType][1] == g_i18n:getText("BM_MODDING_PALLETS") then
		if self.currentUnloadSide[self.unloadSide][1] == g_i18n:getText("UNLOAD_TRAILER") then
			setVisibility(self.gitterBM_ModdingPaletten, self.fillLevel > 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, self.fillLevel == 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, self.fillLevel == 0);
		else	
			setVisibility(self.gitterBM_ModdingPaletten, self.fillLevel >= 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, false);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, false);
		end;
		
		setVisibility(self.gitterWollPaletten, false);
		setVisibility(self.gitterStandardPaletten, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex1, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex2, false);
	
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette1, self.fillLevel == 1);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette2, self.fillLevel == 2);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette3, self.fillLevel == 3);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette4, self.fillLevel == 4);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette5, self.fillLevel == 5);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette6, self.fillLevel == 6);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette7, self.fillLevel == 7);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette8, self.fillLevel == 8);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette9, self.fillLevel == 9);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette10, self.fillLevel == 10);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette11, self.fillLevel == 11);
		setVisibility(self.antirutschmatte.BM_ModdingPaletten.palette12, self.fillLevel == 12);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("WOOLPALLET") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BUYABLE_BLADES")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("PALLET")
	then
		setVisibility(self.antirutschmatte.standardPaletten.palette1, self.fillLevel == 1);
		setVisibility(self.antirutschmatte.standardPaletten.palette2, self.fillLevel == 2);
		setVisibility(self.antirutschmatte.standardPaletten.palette3, self.fillLevel == 3);
		setVisibility(self.antirutschmatte.standardPaletten.palette4, self.fillLevel == 4);
		setVisibility(self.antirutschmatte.standardPaletten.palette5, self.fillLevel == 5);
		setVisibility(self.antirutschmatte.standardPaletten.palette6, self.fillLevel == 6);
		setVisibility(self.antirutschmatte.standardPaletten.palette7, self.fillLevel == 7);
		setVisibility(self.antirutschmatte.standardPaletten.palette8, self.fillLevel == 8);
		setVisibility(self.antirutschmatte.standardPaletten.palette9, self.fillLevel == 9);
		setVisibility(self.antirutschmatte.standardPaletten.palette10, self.fillLevel == 10);
		setVisibility(self.antirutschmatte.standardPaletten.palette11, self.fillLevel == 11);
		setVisibility(self.antirutschmatte.standardPaletten.palette12, self.fillLevel == 12);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("CONSUMPTION_GOODS") then
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette1, self.fillLevel == 1);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette2, self.fillLevel == 2);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette3, self.fillLevel == 3);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette4, self.fillLevel == 4);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette5, self.fillLevel == 5);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette6, self.fillLevel == 6);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette7, self.fillLevel == 7);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette8, self.fillLevel == 8);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette9, self.fillLevel == 9);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette10, self.fillLevel == 10);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette11, self.fillLevel == 11);
		setVisibility(self.antirutschmatte.verbrauchsgueter.palette12, self.fillLevel == 12);
	end;
	
	if self.choosenProductType[self.productType][1] == g_i18n:getText("BUYABLE_BLADES") then
		if self.currentUnloadSide[self.unloadSide][1] == g_i18n:getText("UNLOAD_TRAILER") then
			setVisibility(self.gitterStandardPaletten, self.fillLevel > 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, self.fillLevel == 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, self.fillLevel == 0);
		else	
			setVisibility(self.gitterStandardPaletten, self.fillLevel >= 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, false);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, false);
		end;
		
		setVisibility(self.gitterWollPaletten, false);
		setVisibility(self.gitterBM_ModdingPaletten, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex1, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex2, false);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("WOOLPALLET") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("CONSUMPTION_GOODS")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("PALLET")
	then
		if self.currentUnloadSide[self.unloadSide][1] == g_i18n:getText("UNLOAD_TRAILER") then
			setVisibility(self.gitterWollPaletten, self.fillLevel > 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, self.fillLevel == 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, self.fillLevel == 0);
		else	
			setVisibility(self.gitterWollPaletten, self.fillLevel >= 0);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, false);
			setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, false);
		end;
		
		setVisibility(self.gitterStandardPaletten, false);
		setVisibility(self.gitterBM_ModdingPaletten, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex1, false);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex2, false);
	
	elseif self.choosenProductType[self.productType][1] == g_i18n:getText("STRAW_SQUAREBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("HAY_SQUAREBALE") 
		or self.choosenProductType[self.productType][1] == g_i18n:getText("GRASS_SQUAREBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("MIX_SQUAREBALE")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("STANDARD_TREESAPLINGPALLET")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BIG_TREESAPLINGPALLET")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("H_MILK")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("BOARDPALLET")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("WASHEDPOTATOPALLET")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("TRANSPORTBOX")
		or self.choosenProductType[self.productType][1] == g_i18n:getText("SILAGE_ADDITIVES_TANK")
	then
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex1, true);
		setVisibility(self.variableBodyParts.variableBodyPart2.visibleIndex2, true);
		setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex1, false);
		setVisibility(self.variableBodyParts.variableBodyPart1.visibleIndex2, false);
		setVisibility(self.gitterWollPaletten, false);
		setVisibility(self.gitterStandardPaletten, false);
		setVisibility(self.gitterBM_ModdingPaletten, false);
	end;
end;

function FlieglMain_Extension_DPW180:draw()
end;